'use strict';

var Decorator = {

	entity: null,

	decorate: function(entity) {

		this.entity = entity;

		// expose the given entity properties
		// ideally we should be using Proxy(), sample below
		for (var prop in entity) {
			this[prop] = entity[prop]; 
		}   

		return this;
	}

};

// Proxy()
// 
// Decorator = new Proxy(Decorator, {
//     get: function(target, name) {
//         if (!(name in target.entity)) {
//             console.log("Getting non-existant property '" + name + "'");
//             return undefined;
//         }
//         return target[name];
//     },

//     // not implemented, we dont want to be
//     set: function(target, name, value) {
//         //throw new Error('You should not be setting properties on a Decorated object');
//     }
// });




module.exports = Decorator;


